<?php

if( ! class_exists( 'cache' ) )
{
	require_once( dirname( dirname(__FILE__) ) .'/pear/Cache/Lite.php' );

	class cache
	{
		var $cache ;
		var	$automaticCleaningFactor = 20 ;
		var	$automaticSerialization  = true ;
		var	$fileNameProtection      = true ;

		function cache( $lifeTime = 0 , $debug = false )
		{
			$option = array(
				'cacheDir'                => dirname( dirname(__FILE__) ) .'/cache/' ,
				'lifeTime'                => ( ! empty( $lifeTime ) ) ? $lifeTime : ( ( defined( 'CASHE_LIMIT' ) ) ? intval( CASHE_LIMIT ) :  ( 60 * 60 * 24 ) * 7 ) ,
				'automaticCleaningFactor' => ( ! empty( $lifeTime ) ) ? 0 : $this->automaticCleaningFactor ,
				'automaticSerialization'  => $this->automaticSerialization ,
				'fileNameProtection'      => $this->fileNameProtection ,
			) ;
			$this->cache = new Cache_Lite( $option ) ;
			if ( $debug ) $this->cache->setToDebug() ;
		}

		function save( $value , $cache_id , $group )
		{
			return $this->cache->save( array( 'time' => time_ex() , 'value' => $value ) , $cache_id , $group ) ;
		}

		function get( $cache_id , $group , $with_time = false )
		{
			$data = $this->cache->get( $cache_id , $group ) ;
			return ( empty( $data ) ) ? null : ( ( empty( $with_time ) ) ? $data[ 'value' ] : $data ) ;
 		}

		function clean( $group = false , $mode = 'old' )
		{
			return $this->cache->clean( $group , $mode ) ;
		}

		function lastModified( $cache_id , $group )
		{
			$data = $this->cache->get( $cache_id , $group ) ;
			return ( ! empty( $data ) && is_digit( $data[ 'time' ] ) ) ? $data[ 'time' ] : null ;
		}

		function remove( $cache_id, $group )
		{
			$data = $this->cache->get( $cache_id , $group ) ;
			return ( empty( $data ) ) ? false : $this->cache->remove( $cache_id , $group ) ;
 		}
	}
}

?>
