<?php
/*!
 * Copyright goodsmore <http://goodsmore.net/>
 * version 1.03
 * Dual licensed under the MIT or GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 */

if ( ! function_exists('ajax_load') ) {
	function ajax_load()
	{
		$array = array() ;
		list( $result , $id , $callback ) = get_requests() ;
		if ( ! $result ) die( 'illegal access.' ) ;
		if ( ! empty ( $id ) && ! empty ( $result ) ) $array = array(
			'sozai'    => get_sozai( $id ) ,
			'width'    => intval( MOSHIMO_SOZAI_WIDTH )  ,
			'sozai_id' => MOSHIMO_SOZAI_ID ,
			'addclass' => MOSHIMO_SOZAI_ADDCLASS ,
			'duration' => intval( MOSHIMO_SOZAI_DURATION )  ,
		) ;
		$json_value	= json_encode( $array ) ;
		if( function_exists( 'mb_http_output' ) ) {
			mb_http_output('pass');
		}
		$mtype = ( ! empty( $callback ) ) ? 'text/javascript' : 'application/json' ;
		header( 'Content-Type: '.$mtype.' ; charset=utf-8' ) ;
		if ( empty( $callback ) ) header( 'X-Content-Type-Options: nosniff' ) ;
		echo ( ! empty( $callback ) ) ? $callback . '(' . $json_value . ');' : $json_value ;
	}
}

if ( ! function_exists('get_requests') ) {
	function get_requests()
	{
		$requests_int  = array( 'id' ) ;
		$requests_text = array( 'callback' , 'password' , 'host' ) ;

		foreach( $requests_int as $key ) {
			$$key = ( ! empty( $_GET[ $key ] ) ) ? intval( @$_GET[ $key ] ) : 0 ;
		}
		foreach( $requests_text as $key ) {
			$$key = ( ! empty( $_GET[ $key ] ) ) ? trim( stripSlashesGPC( @$_GET[ $key ] ) ) : '' ;
		}
		$result = ( empty ( $callback ) ) ? isAjax() : checkJsonp( $password , $host ) ;
		return array( $result , $id , $callback ) ;
	}
}

if ( ! function_exists('fetch_url') ) {
	function fetch_url( $url , $params = array() , $method = 'GET' , $options = array() )
	{
		$default = array(
			'curl'      => true ,
			'timeout'   => 0 ,
			'useragent' => 'PHP/' . phpversion() ,
		) ;
		$OPTIONS = ( ! empty ( $options ) ) ? array_merge( $default , (array)$options ) : $default ;
		foreach ( $OPTIONS as $key => $v ) {
			$$key = $v ;
		}
		switch ( true ) {
			case ( ! $curl ) :
			case ( ! function_exists('curl_init') ) :
			 	include_once( 'class/snoopy.php' ) ;
				$snoopy = new Snoopy() ;
				$snoopy->proxy_host  = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_HOST : '' ;
				$snoopy->proxy_port  = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_PORT : 8080 ;
				$snoopy->proxy_user  = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_USER : '' ;
				$snoopy->proxy_pass  = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_PASS : '' ;
				if ( ! empty ( $timeout ) ) $snoopy->_fp_timeout = $timeout ;
				$snoopy->agent       = ( ! empty ( $useragent ) ) ? $useragent : 'PHP/' . phpversion() ;
				$data                = ( $method === 'GET' && ! empty ( $params ) ) ? http_query( $params ) : '' ;
				$url                 = ( $method === 'GET' && ! empty ( $data ) ) ? $url . '?' . $data : $url ;
				$result              = ( $method === 'POST' && ! empty ( $params ) ) ? $snoopy->submit( $url, $params ) : $snoopy->fetch( $url ) ;
				$body                = $snoopy->results ;
				$status              = ( ! empty ( $snoopy->response_code ) ) ? explode( ' ', $snoopy->response_code , 3 ) : array() ;
				$http_code           = ( ! empty ( $status[1] ) ) ? (int)$status[1] : 0 ;
				$rs                  = ( $result && $http_code == 200 ) ? true : false ;
				$response_code       = $snoopy->response_code ;
				$error               = $snoopy->error ;
				$lastredirectaddr    = $snoopy->lastredirectaddr ;
				break ;
			default :
				$data          = ( ! empty ( $params ) ) ? http_query( $params ) : '' ;
				$url           = ( $method === 'GET' && ! empty ( $data ) ) ? $url . '?' . $data : $url ;
				$proxy_port    = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_PORT : 8080 ;
				$proxy_userpwd = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' && defined( 'PROXY_USER' ) && PROXY_USER !== '' ) ? PROXY_USER . ':' . PROXY_PASS : false ;
				$curl = curl_init( $url ) ;
				if( $method == 'POST' ) {
					curl_setopt( $curl,CURLOPT_POST , true ) ;
					curl_setopt( $curl,CURLOPT_POSTFIELDS , $data ) ;
				}
				curl_setopt( $curl, CURLOPT_HEADER , true ) ;
				curl_setopt( $curl, CURLOPT_RETURNTRANSFER , true ) ;
				curl_setopt( $curl, CURLOPT_SSL_VERIFYPEER , false ) ;
				curl_setopt( $curl, CURLOPT_SSL_VERIFYHOST , false ) ;
				if ( ! empty ( $timeout ) ) {
					curl_setopt( $curl, CURLOPT_TIMEOUT, $timeout ) ;
				}
				curl_setopt( $curl, CURLOPT_FAILONERROR , false ) ;
				if ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) {
					curl_setopt( $curl, CURLOPT_PROXY , PROXY_HOST . ':' . $proxy_port ) ;
					curl_setopt( $curl, CURLOPT_PROXYUSERPWD , $proxy_userpwd ) ;
				}
				if ( ! empty ( $useragent ) ) {
					curl_setopt( $curl, CURLOPT_USERAGENT , $useragent ) ;
				}
				$response         = curl_exec( $curl ) ;
				$header_size      = ( ! empty ( $response ) ) ? curl_getinfo( $curl, CURLINFO_HEADER_SIZE ) : 0 ;
				$header           = ( ! empty ( $response ) ) ? substr( $response, 0, $header_size ) : null ;
				$body             = ( ! empty ( $response ) ) ? substr( $response, $header_size ) : null ;
				$error            = curl_error( $curl ) ;
				$errno            = curl_errno( $curl ) ;
				$http_code        = curl_getinfo( $curl , CURLINFO_HTTP_CODE ) ;
				$lastredirectaddr = curl_getinfo( $curl , CURLINFO_EFFECTIVE_URL ) ;
				curl_close( $curl ) ;
				$rs = ( ! empty( $body ) && $http_code === 200 ) ? true : false ;
				list( $response_code ) = explode( "\n", $header , 2 ) ;
				//list( $response_code ) = preg_split( '#(\r\n|\r|\n){2}#' , $header, 2 , PREG_SPLIT_NO_EMPTY ) ;
		}
		return array( $body, $rs, $response_code, $error, $lastredirectaddr, $http_code ) ;
	}
}

if ( ! function_exists('fetch_multi_url') ) {
	function fetch_multi_url( $urls , $options = array() ) {
		$body = $rs = $response_code = $error = $http_code = array() ;
		$default = array(
			'timeout'   => 0 ,
			'useragent' => 'PHP/' . phpversion() ,
		) ;
		$OPTIONS = ( ! empty ( $options ) ) ? array_merge( $default , (array)$options ) : $default ;
		switch ( true ) {
			case ( ! function_exists( 'curl_multi_init' ) ) :
				foreach ( $urls as $i => $url ) {
					$arr = fetch_url( $url , array() , 'GET' , $OPTIONS ) ;
					$body[ $i ]          = $arr[ 0 ] ;
					$rs[ $i ]            = $arr[ 1 ] ;
					$response_code[ $i ] = $arr[ 2 ] ;
					$error[ $i ]         = $arr[ 3 ] ;
					$http_code[ $i ]     = $arr[ 5 ] ;
				}
				break ;
			default :
				foreach ( $OPTIONS as $key => $v ) {
					$$key = $v ;
				}
				$proxy_port    = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) ? PROXY_PORT : 8080 ;
				$proxy_userpwd = ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' && defined( 'PROXY_USER' ) && PROXY_USER !== '' ) ? PROXY_USER . ':' . PROXY_PASS : false ;
				$mh            = curl_multi_init() ;
				if ( function_exists('curl_multi_setopt') ) {
					curl_multi_setopt( $mh , CURLMOPT_PIPELINING , true ) ;
				}
				foreach ( $urls as $i => $url ) {
					$conn[$i] = curl_init( $url ) ;
					curl_setopt( $conn[$i], CURLOPT_HEADER , true ) ;
					curl_setopt( $conn[$i], CURLOPT_RETURNTRANSFER , true ) ;
					curl_setopt( $conn[$i], CURLOPT_SSL_VERIFYPEER , false ) ;
					curl_setopt( $conn[$i], CURLOPT_SSL_VERIFYHOST , false ) ;
					curl_setopt( $conn[$i], CURLOPT_FAILONERROR , false ) ;
					if ( ! empty ( $timeout ) ) {
						curl_setopt( $conn[$i] ,CURLOPT_TIMEOUT , $timeout ) ;
					}
					if ( defined( 'PROXY_HOST' ) && PROXY_HOST !== '' ) {
						curl_setopt( $conn[ $i ], CURLOPT_PROXY , PROXY_HOST . ':' . $proxy_port ) ;
						curl_setopt( $conn[ $i ], CURLOPT_PROXYUSERPWD , $proxy_userpwd ) ;
					}
					if ( ! empty ( $useragent ) ) {
						curl_setopt( $conn[ $i ], CURLOPT_USERAGENT , $useragent ) ;
					}
					curl_multi_add_handle( $mh , $conn[$i] ) ;
				}
				$active = null ;
				do {
					$mrc = curl_multi_exec( $mh , $active ) ;
				} while ( $mrc == CURLM_CALL_MULTI_PERFORM ) ;
		
				while ( $active && $mrc == CURLM_OK ) {
					if ( curl_multi_select( $mh ) == -1 ) { 
						usleep( 100 ) ;
					}
					do $mrc = curl_multi_exec( $mh, $active ) ;
					while ( $mrc == CURLM_CALL_MULTI_PERFORM ) ;
				}
				foreach ( $urls as $i => $url ) {
					$response          = curl_multi_getcontent( $conn[$i] )  ;
					$header_size       = ( ! empty ( $response ) ) ? curl_getinfo( $conn[$i], CURLINFO_HEADER_SIZE ) : 0 ;
					$header            = ( ! empty ( $response ) ) ? substr( $response, 0, $header_size ) : null ;
					$body[$i]          = ( ! empty ( $response ) ) ? substr( $response, $header_size ) : null ;
					$http_code[$i]     = curl_getinfo( $conn[$i] , CURLINFO_HTTP_CODE ) ;
					$rs[$i]            = ( ! empty( $response ) && $http_code[$i] === 200 ) ? true : false ;
					$error[$i]         = curl_error( $conn[$i] ) ;
					list( $_response ) = explode( "\n", $header , 2 ) ;
					$response_code[$i] = $_response ;
					curl_multi_remove_handle( $mh , $conn[$i] ) ;
					curl_close( $conn[$i] ) ;
				}
				curl_multi_close( $mh ) ;
		}
		return array( $body , $rs , $response_code , $error , $http_code ) ;
	}
}

if ( ! function_exists('http_query') ) {
	function http_query( $params )
	{
		if( ! function_exists( 'http_build_query' ) ) {
			require_once( 'class/upgrade.php' ) ;
		}
		return ( ! empty ( $params ) ) ? http_build_query( $params , '' , '&' ) : '' ;
	}
}

if ( ! function_exists('return_xml') ) {
	function return_xml( $req , $id = 0 )
	{
		list( $xml , $results , $response , $error ) = fetch_url( $req ) ;
		$status = ( ! empty ( $id ) ) ? responseLog( $response, $error, $id ) : true ;
		switch ( true ) {
			case ( function_exists( 'simplexml_load_string' ) ) :
				return ( ! empty ( $results ) && $status ) ? simplexml_load_string( deleteControlCode( $xml ) ) : array() ;
			default :
	 			include_once( 'class/xml.php' ) ;
				return ( ! empty ( $results ) && $status ) ? XML_unserialize( deleteControlCode( $xml ) ) : array() ;
		}
	}
}

if ( ! function_exists('responseLog') ) {
	function responseLog( $response , $error , $id )
	{
		if( ! function_exists( 'array_replace' ) ) {
			require_once( 'class/upgrade.php' ) ;
		}
		$file   = dirname( __FILE__ ) . '/cache/response.log' ;
		$array  = ( file_exists( $file ) ) ? file( $file ) : array() ;
		$status = ( ! empty ( $response ) ) ? array_replace( explode( ' ' , $response , 3 ), array( $id ) ) : array( $id ) ;
		if ( ! empty ( $error ) ) array_push( $status , $error ) ;
		array_unshift( $array , '[' . date_ex( 'Y n j G:i:s' ) . '] '. implode( ',' , $status ) ) ;
		if ( cacheDirCheck() && $fp = @fopen( $file , 'wb' ) ) {
			fputs( $fp , join( "\n" , array_map( 'deleteControlCode' , limitArray( $array ) ) ) ) ;
			fclose( $fp ) ;
		}
		return ( $status[1] === '200' ) ? true : false ;
	}
}

if ( ! function_exists('request_count') ) {
	function request_count( $c = 1 )
	{
		$file  = dirname( __FILE__ ) . '/cache/request_count.log' ;
		$array = ( file_exists( $file ) && $v = file( $file ) ) ? array_map( 'trim' , $v ) : array() ;
		$count = ( empty( $array ) ) ? $c : ( ( is_digit( $array[0] ) && date_compare( $array[0] , '-60 second' , '<' ) ) ? $c : count( $array ) + $c ) ;
		if ( $count == $c ) $array = array() ;
		for ( $i = 0 ; $i < $c ; $i++ ) {
			array_push( $array , time_ex() ) ;
		}
		if ( cacheDirCheck() && $fp = @fopen( $file , 'wb' ) ) {
			fputs( $fp , join( "\n" , array_map( 'deleteControlCode' , $array ) ) ) ;
			fclose( $fp ) ;
		}
		return $count ;
	}
}

if ( ! function_exists('get_xml') ) {
	function get_xml( $req , $id = 0 , $key = 'ArticleMaterial' )
	{
		if ( request_count() > 90 ) return array() ;
		$xml = return_xml( $req , $id ) ;
		switch ( true ) {
			case ( is_object( $xml ) ) :
				return ( ! empty ( $xml ) ) ? $xml->children() : array() ;
			default :
				return ( ! empty ( $xml ) ) ? $xml[ $key ] : array() ;
		}
	}
}

if ( ! function_exists('get_sozai') ) {
	function get_sozai( $id )
	{
		if ( $data = readCache( $id , 'details' ) ) {
			return $data ;
		} else {
			return make_sozai_cache( $id ) ;
		}
	}
}

if ( ! function_exists('make_sozai_cache') ) {
	function make_sozai_cache( $id )
	{
		$array = array() ;
		$req   = 'http://api.moshimo.com/article/material' ;
		$req  .= '?authorization_code='.AUTHORIZATION_CODE.'&article_id='.$id ;
		$xml   = get_xml( $req , $id , 'ArticleMaterial' ) ;
		$rows  = ( is_object( $xml ) && ! empty( $xml->Rows ) ) ? intval( $xml->Rows ) : ( ( ! empty ( $xml['Rows'] ) ) ? intval( $xml['Rows'] ) : 0 ) ;
		if ( ! defined( 'USE_X_IMAGE' ) ) define( 'USE_X_IMAGE' , true ) ;
		switch ( true ) {
			case ( ! empty( $rows ) && is_object( $xml ) && ! empty( $xml->Materials->Material ) ) :
				$array = $xml->Materials->Material ;
				break ;
			case ( ! empty( $rows ) && ! empty( $xml['Materials']['Material'][0] ) && is_array( $xml['Materials']['Material'][0] ) ) :
				$array = $xml['Materials']['Material'] ;
				break ;
			case ( ! empty( $rows ) && ! empty( $xml['Materials'] ) && is_array( $xml['Materials'] ) ) :
				$array = $xml['Materials'] ;
				break ;
			case ( USE_X_IMAGE === true ) :
				$array = get_item_xml( $id ) ;
				break ;
		}
		$string = ( ! empty( $array ) ) ? get_exec( $array , $id ) :  '' ;
		return $string ;
	}
}

if ( ! function_exists('get_item_xml') ) {
	function get_item_xml( $id )
	{
		$array = $urls = array() ;
		$req  = 'http://api.moshimo.com/article/search' ;
		$req .= '?authorization_code='.AUTHORIZATION_CODE.'&article_id='.$id ;
		$xml  = get_xml( $req , $id , 'ArticleSearch' ) ;
		$rows = ( is_object( $xml ) && ! empty( $xml->Rows ) ) ? intval( $xml->Rows ) : ( ( is_array( $xml ) && ! empty ( $xml['Rows'] ) ) ? intval( $xml['Rows'] ) : 0 ) ;
		if( ! empty( $rows ) ) {
			$item  = ( is_object( $xml ) && ! empty( $xml->Articles->Article ) ) ? $xml->Articles->Article : ( ( ! empty ( $xml['Articles'] ) ) ? reset( $xml['Articles'] ) : null ) ;
			$count = ( is_object( $item ) && ! empty( $item->ImageCount ) ) ? intval( $item->ImageCount ) : ( ( is_array( $item ) && ! empty( $item['ImageCount'] ) ) ? intval( $item['ImageCount'] ) : 0 ) ;
			$code  = ( is_object( $item ) && ! empty( $item->ImageCode ) ) ? trim( $item->ImageCode ) : ( ( is_array( $item ) && ! empty( $item['ImageCode'] ) ) ? trim( $item['ImageCode'] ) : '' ) ;
			if ( empty( $count ) || empty( $code ) ) return $array ;
			for ( $i = 1 ; $i <= $count ; $i++ ) {
				$urls[ $i ] = 'http://image.moshimo.com/item_image/' . $code . '/' . $i . '/x.jpg' ;
			}
			list( $body , $results ) = fetch_multi_url( $urls ) ;
			foreach( $results as $key => $rs ) {
				if( $rs ) $array[] = array(
					'Type' => 1 ,
					'Data' => $urls[ $key ] ,
				) ;
			}
		}
		return $array ;
	}
}

if ( ! function_exists('get_exec') ) {
	function get_exec( &$array , $id )
	{
		$string = '' ;
		$i      = 1 ;
		if( ! empty( $array ) ) foreach ( $array as $item ) {
			$type = ( is_object( $item ) && ! empty( $item->Type ) ) ? intval( $item->Type ) : ( ( is_array( $item ) && ! empty( $item['Type'] ) ) ? intval( $item['Type'] ) : 0 ) ;
			if ( $type == 0 ) continue ;
			$data = ( is_object( $item ) && ! empty( $item->Data ) ) ? trim( $item->Data ) : ( ( is_array( $item ) && ! empty( $item['Data'] ) ) ? trim( $item['Data'] ) : '' ) ;
			if ( ! empty( $data ) ) switch( true ) {
				case ( $type == 5 ) :
					$string .= $data ;
					break ;
				default :
					$string .= '<img id="'.MOSHIMO_SOZAI_ID.$i.'"src="'.toShow( $data ) .'" />' ;
					break ;
			}
			$i++ ;
		}
		makeCache( $string , $id , 'details' ) ;
		return $string ;
	}
}

if ( ! function_exists('makeCache') ) {
	function makeCache( $value , $cache_id , $group , $lifeTime = 0 )
	{
		if ( cacheDirCheck( $lifeTime ) ) {
			include_once( 'class/cache.php' ) ;
			$cache = new cache( $lifeTime ) ;
			$cache->save( $value , $cache_id , $group ) ;
		}
	}
}

if ( ! function_exists('readCache') ) {
	function readCache( $cache_id , $group , $time = false , $lifeTime = 0 )
	{
		include_once( 'class/cache.php' ) ;
		$cache = new cache( $lifeTime ) ;
		return $cache->get( $cache_id , $group , $time ) ;
	}
}

if ( ! function_exists('cacheDirCheck') ) {
	function cacheDirCheck( $lifeTime = 0 )
	{
		$result    = true ;
		$dir       = 'cache' ;
		$safe_mode = ini_get( 'safe_mode' ) ;
		if ( ! is_dir( $dir ) ) {
			if ( $safe_mode ) $result = false ;
			$mrs = mkdir( $dir , 0777 ) ;
			if ( ! $mrs ) $result = false ;
			else @chmod( $dir , 0777 ) ;
		}
		if ( ! is_writable( $dir ) || ! is_readable( $dir ) ) {
			$mrs = chmod( $dir , 0777 ) ;
			if ( ! $mrs ) $result = false ; ;
		}
		if ( is_writable( $dir ) && empty( $lifeTime ) ) removeCache( $lifeTime ) ;
		return $result ;
	}
}

if ( ! function_exists('removeCache') ) {
	function removeCache( $lifeTime = 0 , $automaticCleaningFactor = 20 )
	{
		if ( empty( $lifeTime ) && mt_rand( 1 , $automaticCleaningFactor ) == 1 ) {
			include_once( 'class/cache.php' ) ;
			if( ! function_exists( 'scandir' ) ) {
				require_once( 'class/upgrade.php' ) ;
			}
			$cache   = new cache( $lifeTime ) ;
			$dirname = 'cache' ;
			$files   = array_diff( scandir( $dirname ) , array( '.' , '..' ) ) ;
			switch ( true ) {
				case ( count( $files ) >= 200 ) :
					$cache->clean( false , 'callback_cleanCache' ) ;
					break ;
				case ( count( $files ) >= 100 ) :
					$cache->clean( false , 'callback_CacheCleaning' ) ;
					break ;
			}
			foreach( $files as $v ) {
				if ( preg_match( '#(\.php|\.cache)$#i', $v ) ) {
					@unlink( $dirname . '/' . $v ) ;
				}
			}
		}
	}
}

if ( ! function_exists('cleanCache') ) {
	function cleanCache( $file, $group )
	{
		$limit = '-3 hours' ;
		return ( date_compare( $limit , filemtime( $file ) , '>' ) ) ? true : false ;
	}
}

if ( ! function_exists('CacheCleaning') ) {
	function CacheCleaning( $file , $group )
	{
		$define = ( defined( 'CASHE_LIMIT' ) ) ? intval( CASHE_LIMIT ) : ( 60 * 60 * 24 ) * 7 ;
		$define = intval( $define * ( 2 / 3 ) )  ;
		$limit  = '-' . $define . ' second' ;
		return ( date_compare( $limit , filemtime( $file ) , '>' ) ) ? true : false ;
	}
}

if ( ! function_exists('checkJsonp') ) {
	function checkJsonp( $password , $host )
	{
		$result = 0 ;
		if ( JSONP_PASSWORD === '' || empty( $password ) ) return false ;
		if ( is_sameValue( $password, JSONP_PASSWORD ) ) $result++ ;
		$array = explode( ',' , JSONP_CHECK_HOST ) ;
		foreach ( $array as $value ) {
			if ( is_sameValue( trim( $value ) , $host ) ) {
				$result++ ;
				break ;
			}
		}
		return ( $result == 2 ) ? true : false ;
	}
}

if ( ! function_exists('is_sameValue') ) {
	function is_sameValue( $str1 , $str2 )
	{
		return ( strcmp( $str1 , $str2 ) == 0 ) ? true : false ;
	}
}

if ( ! function_exists('is_digit') ) {
	function is_digit( $value )
	{
		switch ( true ) {
			case ( function_exists( 'ctype_digit' ) ) :
				return ctype_digit( (string)$value ) ;
			default:
				return (bool)preg_match( '#^[[:digit:]]+$#', $value ) ;
		}
	}
}

if ( ! function_exists('limitArray') ) {
	function limitArray( $array , $limit = 1000 )
	{
		$count = count( $array ) - $limit ;
		if( $count > 0 ) array_splice( $array , $limit , $count ) ;
		return $array ;
	}
}

if ( ! function_exists('toShow') ) {
	function toShow( $arr )
	{
		if ( is_array( $arr ) ) {
			return array_map( 'toShow', $arr ) ;
		} else {
			return preg_replace( "/&amp;(#[0-9]+|#x[0-9a-f]+|[a-z]+[0-9]*);/i", '&\\1;', htmlspecialchars( $arr , ENT_QUOTES , 'UTF-8' ) ) ;
		}
	}
}


if ( ! function_exists('stripSlashesGPC') ) {
	function &stripSlashesGPC( $str )
	{
		return ( get_magic_quotes_gpc() ) ? stripslashes( $str ) : $str ;
	}
}

if ( ! function_exists('deleteControlCode') ) {
	function deleteControlCode( $str )
	{
		return preg_replace( '#[\x00-\x1f\x7f]#', '' , $str ) ;
	}
}

if ( ! function_exists('isAjax') ) {
	function isAjax() {
		$env = ( $v = @$_SERVER['HTTP_X_REQUESTED_WITH'] ) ? strtolower( $v ) : null ;
		if ( empty( $env ) && function_exists( 'apache_request_headers' ) ) {
			$headers = array_change_key_case( apache_request_headers() , CASE_LOWER ) ;
			$env     = ( ! empty( $headers['x-requested-with'] ) && $v = $headers['x-requested-with'] ) ? strtolower( $v ) : null ;
		}
		switch ( true ) {
			case ( empty( $env ) ) :
			case ( $env !== 'xmlhttprequest' ) :
				return false ;
			default:
				return true ;
		}
	}
}

if ( ! function_exists('time_ex') ) {
	function time_ex() {
		switch ( true ) {
			case ( class_exists( 'DateTime' ) ) :
				$obj = new DateTime() ;
				return ( $v = $obj->format( 'U' ) ) ? $v : false ;
			default :
				return time() ;
		}
	}
}

if ( ! function_exists('date_ex') ) {
	function date_ex( $format = null , $value = 'now' , $gmt = false ) {
		$format = ( empty( $format ) ) ? 'Y-n-j H:i' : $format ;
		switch ( true ) {
			case ( is_digit( $value ) && class_exists( 'DateTime' ) ) :
				$obj = new DateTime( "@$value" ) ;
				if ( $gmt === false ) $obj->setTimezone( new DateTimeZone( ini_get( 'date.timezone' ) ) ) ;
				return ( $v = $obj->format( $format ) ) ? $v : false ;
			case ( class_exists( 'DateTime' ) ) :
				$obj = new DateTime( $value ) ;
				if ( $gmt === true ) $obj->setTimezone( new DateTimeZone( 'UTC' ) ) ;
				return ( $v = $obj->format( $format ) ) ? $v : false ;
			default :
				$time = ( is_digit( $value ) ) ? (int)$value : ( ( $value === 'now' ) ? time() : strtotime( $value ) ) ;
				return ( $time === false || $time === -1 ) ? false : ( ( $gmt === true ) ? gmdate( $format , $time ) : date( $format , $time ) ) ;
		}
	}
}

if ( ! function_exists('date_compare') ) {
	function date_compare( $date1 , $date2 , $operator = '<' )
	{
		switch ( true ) {
			case ( class_exists( 'DateTime' ) && version_compare( PHP_VERSION, '5.2.2' , '>=' ) ) :
				$from = ( is_digit( $date1 ) ) ? new DateTime( "@$date1" ) : new DateTime( $date1 ) ;
				$from->setTimezone( new DateTimeZone( ini_get( 'date.timezone' ) ) ) ;
				$to   = ( is_digit( $date2 ) ) ? new DateTime( "@$date2" ) : new DateTime( $date2 ) ;
				$to->setTimezone( new DateTimeZone( ini_get( 'date.timezone' ) ) ) ;
				break ;
			default :
				$from = ( is_digit( $date1 ) ) ? (int)$date1 : ( ( $date1 === 'now' ) ? time() : strtotime( $date1 ) ) ;
				$to   = ( is_digit( $date2 ) ) ? (int)$date2 : ( ( $date2 === 'now' ) ? time() : strtotime( $date2 ) ) ;
		}
		switch ( $operator ) {
			case '>' :
				return (bool)( $from > $to ) ;
			case '>=' :
				return (bool)( $from >= $to ) ;
			case '<=' :
				return (bool)( $from <= $to ) ;
			case '==' :
				return (bool)( $from == $to ) ;
			case '!=' :
				return (bool)( $from != $to ) ;
			case '<' :
				return (bool)( $from < $to ) ;
			default :
				return ;
		}
	}
}

if ( ! function_exists('json_decode') ) {
	function json_decode( $data, $assoc = false )
	{
		include_once( 'Services/JSON.php' ) ;
		$json = ( ! empty( $assoc ) ) ? new Services_JSON( SERVICES_JSON_LOOSE_TYPE ) : new Services_JSON() ;
		return $json->decode( $data ) ;
	}
}

if ( ! function_exists('json_encode') ) {
	function json_encode( $data )
	{
		include_once( 'Services/JSON.php' ) ;
		$json = new Services_JSON() ;
		return $json->encodeUnsafe( $data ) ;
	}
}

?>